      parameter(nvars=6,nz=1000)

      character imo*3,ch1*1,ch2*1,wsunit*2,hr*2,dy*2,mo*3,yr*4
      real var(nz,6)

C     Input:  sounding ascii data  
C     Data source: http://esrl.noaa.gov/raobs/
      open( 1,file='raob_soundings7076.tmp')
      
C     Output:  sounding binary data & ctl file  
      open(10,file='raob.dat',form='unformatted')
      open(20,file='raob.ctl')

      read( 1,10) hr,dy,mo,yr
      read( 1,15) ik1,iwban,iwmo,rlat,ch1,rlon,ch2,ielev,itime
      read( 1,20) ik2,ihydro,imxwd,itropl,iline,itindex,isource
      read( 1,25) staid,isonde,wsunit
      read( 1,20) ik3,iprs1,ihgt1,itmp1,idwp1,idir1,ispd1 

      levs = iline - 5 

      do k = 1,levs
        read( 1,20) ik4,iprs,ihgt,itmp,idwp,idir,ispd 
        var(k,1) = real(iprs)/10.
        var(k,2) = real(ihgt)
        var(k,3) = real(itmp)/10.
        var(k,4) = real(idwp)/10.
        if(idir.eq.99999) var(k,5) = real(idir)/10.
        if(idir.ne.99999) var(k,5) = real(idir)
        if(ispd.eq.99999) var(k,6) = real(ispd)/10.
        if(ispd.ne.99999) var(k,6) = real(ispd)
        write(*,30)' prs: ',var(k,1),' hgt: ',var(k,2), 
     &             ' tmp: ',var(k,3),' dwp: ',var(k,4), 
     &             ' dir: ',var(k,5),' spd: ',var(k,6) 
      enddo

      do l = 1,nvars
         do k = 1,levs
           write(10) var(k,l)
         enddo
      enddo

C     Creating ctl file
      write(20,101)
      write(20,102) iwmo
      write(20,103)
      write(20,104)
      write(20,105)
      write(20,106)
      write(20,107) levs
      write(20,108)(var(i,1),i=1,levs)
      write(20,109) hr,dy,mo,yr
      write(20,110)
      write(20,111) levs
      write(20,112) levs
      write(20,113) levs
      write(20,114) levs
      write(20,115) levs
      write(20,116) levs
      write(20,117)

 10   format(12x,a2,5x,a2,6x,a3,4x,a4) 
 15   format(3i7,f7.2,a1,f6.2,a1,i6,i7)
 20   format(7i7)
 25   format(17x,a4,14x,i7,5x,a2)
 30   format(a6,1x,f6.1,1x,a6,f7.1,1x,4(a6,1x,f7.1))

101   format('dset raob.dat      ')
102   format('title Sounding Data: ',i7)
103   format('options sequential  ')
104   format('undef 9999.9        ')
105   format('xdef  1 linear 0 1  ')
106   format('ydef  1 linear 0 1  ')
107   format('zdef ',i5' levels ')
108   format(10f7.1)
109   format('tdef 1 linear ',a2,'Z',a2,a3,a4,' 12hr')
110   format('vars 6')
111   format('prs ',i5,' 0 pressure (mb)')
112   format('hgt ',i5,' 0 height (m)')
113   format('tmp ',i5,' 0 temperature (oC)')
114   format('dwp ',i5,' 0 dewpoint temperature (oC)')
115   format('dir ',i5,' 0 wind direction (deg)')
116   format('spd ',i5,' 0 wind speed (kt)')
117   format('endvars')

      stop
      end      
